<template>
  <van-cell-group>
    <van-cell icon="facebook">
      <template slot="title">
        <span class="custom-text">Get my data</span>
        <van-tag
          :type="{primary: status === 'not connected', success: status === 'connected'}"
        >{{status}}</van-tag>
      </template>
      <van-button
        v-if="status !== 'connected'"
        plain
        type="primary"
        @click="loginService"
      >Login {{service.name}}</van-button>
      <van-button
        v-if="status === 'connected'"
        plain
        type="primary"
        @click="getServiceData"
      >Update data</van-button>
      <van-button
        v-if="status === 'connected'"
        plain
        type="primary"
        @click="logoutService"
      >Logout {{service.name}}</van-button>
    </van-cell>
    <template v-if="Object.keys(claims).length > 0">
      <van-field v-for="(claim, key) in claims" :key="key" :label="key" v-model="claims[key]"></van-field>
    </template>
  </van-cell-group>
</template>

<script>
import {
  SET_NEW_CLAIMS,
  basePath,
  GET_SERVICE_DID_FROM_NAME
} from "./../actions";
export default {
  name: "Facebook",
  mounted() {
    this.getServiceStatus();
    this.$on("status", status => {
      if (status === "connected") {
        let claims = this.getClaimsForThisService();
      }
    });
  },
  data() {
    return {
      status: "",
      statusText: "Not connected",
      claims: {}
    };
  },
  props: ["service"],
  methods: {
    getServiceStatus() {
      return new Promise(resolve => {
        window.FB.getLoginStatus(res => {
          console.log("facebook getLoginStatus res", res);
          this.status = res.status;
          this.$emit("status", res.status);
          resolve(res.status);
        });
      });
    },
    loginService() {
      window.FB.login(
        res => {
          console.log("result loginService: ", res);
          this.getServiceStatus();
        },
        {
          scope: "public_profile,email"
        }
      );
    },
    logoutService() {
      window.FB.logout(
        res => {
          console.log("result logoutService: ", res);
          this.getServiceStatus();
        },
        {
          scope: "public_profile,email"
        }
      );
    },
    getServiceData() {
      FB.api("/me", { fields: "last_name,email,first_name" }, res => {
        console.log("Response from Facebook", res);
        this.setClaims({
          lastName: res.last_name,
          email: res.email,
          firstName: res.first_name
        });
        return this.getClaimsForThisService();
      });
    },
    setClaims(claims) {
      this.$store.dispatch(basePath(SET_NEW_CLAIMS), {
        serviceName: this.service.name,
        claims
      });
    },
    async getClaimsForThisService() {
      const claims = await this.$store.dispatch(
        basePath(GET_SERVICE_DID_FROM_NAME),
        {
          serviceName: this.service.name
        }
      );
      this.claims = claims;
      return claims;
    }
  }
};

/* 

START FACEBOOK SDK IMPORT

*/

window.fbAsyncInit = function() {
  FB.init({
    appId: "306225683397956",
    cookie: true,
    xfbml: true,
    version: "v3.2"
  });
  FB.AppEvents.logPageView();
};

(function(d, s, id) {
  var js,
    fjs = d.getElementsByTagName(s)[0];
  if (d.getElementById(id)) {
    return;
  }
  js = d.createElement(s);
  js.id = id;
  js.src = "https://connect.facebook.net/en_US/sdk.js";
  fjs.parentNode.insertBefore(js, fjs);
})(document, "script", "facebook-jssdk");

/* 

END FACEBOOK SDK IMPORT

*/
</script>

<style scoped>
</style>